<?php 
define("LICENSE_FILE", DIR . "/contents/datastore/l.dat");
define("STORE_URL", "");
define("DIMOFINFURL", "");
define("SSALT", hash("SHA256", COOKIE_SALT, true));
define("DIMSECRETKEY", "Zyd9Dr5grCEN3cuZo7ZS646wBq");

function fetch_version_array($version)
{
    if( preg_match("#^([a-z]+ )?([0-9\\.]+)[\\s-]*([a-z].*)\$#i", trim($version), $match) ) 
    {
        list(, , $main_version, $sub_version) = $match;
    }
    else
    {
        $main_version = $version;
        $sub_version = "";
    }

    $version_bits = explode(".", $main_version);
    if( sizeof($version_bits) < 4 ) 
    {
        for( $i = sizeof($version_bits); $i < 4; $i++ ) 
        {
            $version_bits[$i] = 0;
        }
    }

    $version_bits[4] = 0;
    $version_bits[5] = 0;
    if( !empty($sub_version) && preg_match("#^(A|ALPHA|B|BETA|G|GAMMA|RC|RELEASE CANDIDATE|GOLD|STABLE|FINAL|PL|PATCH LEVEL)\\s*(\\d*)\\D*\$#i", $sub_version, $match) ) 
    {
        switch( strtoupper($match[1]) ) 
        {
            case "A":
            case "ALPHA":
                $version_bits[4] = -4;
                break;
            case "B":
            case "BETA":
                $version_bits[4] = -3;
                break;
            case "G":
            case "GAMMA":
                $version_bits[4] = -2;
                break;
            case "RC":
            case "RELEASE CANDIDATE":
                $version_bits[4] = -1;
                break;
            case "PL":
            case "PATCH LEVEL":
                $version_bits[4] = 1;
                break;
            case "GOLD":
            case "STABLE":
            case "FINAL":
            default:
                $version_bits[4] = 0;
                break;
        }
        $version_bits[5] = $match[2];
    }

    for( $i = 0; $i <= 5; $i++ ) 
    {
        $version_bits[$i] = intval($version_bits[$i]);
    }
    return $version_bits;
}

function is_newer_version($new_version_str, $cur_version_str)
{
    if( $cur_version_str != $new_version_str ) 
    {
        $cur_version = fetch_version_array($cur_version_str);
        $new_version = fetch_version_array($new_version_str);
        for( $i = 0; $i <= 5; $i++ ) 
        {
            if( $new_version[$i] != $cur_version[$i] ) 
            {
                return $cur_version[$i] < $new_version[$i];
            }

        }
    }

    return false;
}

function lencrypt($text)
{
    return trim(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, SSALT, $text, MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND))));
}

function ldecrypt($text)
{
    return trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, SSALT, base64_decode($text), MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)));
}

function connect_with_host($connecthost, $connectfile, $postfields = array(  ), $firewalluser = "", $firewallpass = "")
{
    if( function_exists("curl_exec") ) 
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $connecthost . $connectfile);
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0");
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 0);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array( "Expect:" ));
        if( !empty($postfields) ) 
        {
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
        }

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        if( $firewalluser ) 
        {
            curl_setopt($ch, CURLOPT_USERPWD, "" . $firewalluser . ":" . $firewallpass . "");
        }

        curl_setopt($ch, CURLOPT_REFERER, "https://" . $_SERVER["SERVER_NAME"]);
        $data = curl_exec($ch);
        curl_close($ch);
    }
    else
    {
        $fp = fsockopen($connecthost, 80, $errno, $errstr, 5);
        if( $fp ) 
        {
            $querystring = "";
            foreach( $postfields as $k => $v ) 
            {
                $querystring .= $k . "=" . urlencode($v) . "&";
            }
            $header = "POST " . $connecthost . $connectfile . " HTTP/1.0\r\n";
            $header .= "Host: " . $connecthost . "\r\n";
            $header .= "Content-type: application/x-www-form-urlencoded\r\n";
            if( $firewalluser ) 
            {
                $header .= "Authorization: Basic " . base64_encode($firewalluser . ":" . $firewallpass) . "\r\n";
            }

            $header .= "Content-length: " . @strlen($querystring) . "\r\n";
            $header .= "Connection: close\r\n\r\n";
            $header .= $querystring;
            $data = "";
            @stream_set_timeout($fp, 20);
            @fputs($fp, $header);
            $status = @socket_get_status($fp);
            while( !@feof($fp) && $status ) 
            {
                $data .= @fgets($fp, 1024);
                $status = @socket_get_status($fp);
            }
            @fclose($fp);
        }

    }

    return $data;
}

function docheck_license($licensekey, $localkey = "", $localkeydays)
{
    global $dimofinf;
    global $hook;
    $check_token = time() . md5(mt_rand(1000000000, 9999999999) . $licensekey);
    $checkdate = date("Ymd");
    $usersip = isset($_SERVER["SERVER_ADDR"]) ? $_SERVER["SERVER_ADDR"] : $_SERVER["LOCAL_ADDR"];
    $allowcheckfaildays = 5;
    $localkeyvalid = false;
    if( $localkey ) 
    {
        $localkey = ldecrypt(str_replace("\n", "", $localkey));
        $localdata = substr($localkey, 0, strlen($localkey) - 32);
        $md5hash = substr($localkey, strlen($localkey) - 32);
        if( $md5hash == md5($localdata . DIMSECRETKEY) ) 
        {
            $localdata = strrev($localdata);
            $md5hash = substr($localdata, 0, 32);
            $localdata = substr($localdata, 32);
            $localdata = base64_decode($localdata);
            $localkeyresults = unserialize($localdata);
            $originalcheckdate = $localkeyresults["checkdate"];
            if( $md5hash == md5($originalcheckdate . DIMSECRETKEY) ) 
            {
                $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - $localkeydays, date("Y")));
                if( $localexpiry < $originalcheckdate ) 
                {
                    $localkeyvalid = true;
                    $results = $localkeyresults;
                    $validdomains = explode(",", $results["validdomain"]);
                    if( !in_array($_SERVER["SERVER_NAME"], $validdomains) ) 
                    {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Invalid";
                        $results = array(  );
                    }

                    $validips = explode(",", $results["validip"]);
                    if( !in_array($usersip, $validips) ) 
                    {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Invalid";
                        $results = array(  );
                    }

                    $validdirectorys = explode(",", $results["validdirectory"]);
                    $currentdirectory = dirname(dirname(dirname(dirname(__FILE__))));
                    if( !in_array($currentdirectory, $validdirectorys) ) 
                    {
                        $path = str_replace("\\", "/", $currentdirectory);
                        $path = explode("/", $path);
                        $path = end($path);
                        if( $path != "upgrade" ) 
                        {
                            $localkeyvalid = false;
                            $localkeyresults["status"] = "Invalid";
                            $results = array(  );
                        }

                    }

                }

            }

        }

    }

    if( !$localkeyvalid ) 
    {

  $data = array (
  'registeredname' => 'TEAM_ECHO_ROCKS',
  'companyname' => '',
  'email' => '',
  'productid' => '256',
  'productname' => 'Owend License',
  'regdate' => '2015-01-01',
  'nextduedate' => '0000-00-00',
  'billingcycle' => 'One Time',
  'validdomain' => $_SERVER['HTTP_HOST'],
  'validip' => $_SERVER['SERVER_ADDR'],
  'storeuserid' => '2',
  'validdirectory' => $_SERVER['DOCUMENT_ROOT'],
  'configoptions' => false,
  'customfields' => 'License Domain=|Category=|Site Title=|Include In Links=',
  'md5hash' => '',
  'addons' => 
  array (
    0 => 
    array (
      'status' => 'Active',
      'nextduedate' => '0000-00-00',
      'name' => 'Support And Updates',
    ),
    1 => 
    array (
      'status' => 'Active',
      'nextduedate' => '0000-00-00',
      'name' => 'No Branding',
    ),
  ),
  'plugins' => 
  array (
    'news' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول الأخبار',
      'nextduedate' => '0000-00-00',
      'pluginid' => '1',
      'style' => 0,
    ),
    'album' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول ألبومات الصور',
      'nextduedate' => '0000-00-00',
      'pluginid' => '2',
      'style' => 0,
    ),
    'article' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول المقالات',
      'nextduedate' => '0000-00-00',
      'pluginid' => '3',
      'style' => 0,
    ),
    'card' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول البطاقات',
      'nextduedate' => '0000-00-00',
      'pluginid' => '4',
      'style' => 0,
    ),
    'mobile' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول الجوال',
      'nextduedate' => '0000-00-00',
      'pluginid' => '5',
      'style' => 0,
    ),
    'video' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول الفيديو',
      'nextduedate' => '0000-00-00',
      'pluginid' => '7',
      'style' => 0,
    ),
    'download' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول الداونلود',
      'nextduedate' => '0000-00-00',
      'pluginid' => '8',
      'style' => 0,
    ),
    'voice' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'موديول الصوتيات',
      'nextduedate' => '0000-00-00',
      'pluginid' => '9',
      'style' => 0,
    ),
    'comment' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'نظام التعليقات',
      'nextduedate' => '0000-00-00',
      'pluginid' => '13',
      'style' => 0,
    ),
    'mediaplayer' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'مشغل الميديا',
      'nextduedate' => '0000-00-00',
      'pluginid' => '20',
      'style' => 0,
    ),
    'rss' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'روابط التغذية rss',
      'nextduedate' => '0000-00-00',
      'pluginid' => '27',
      'style' => 0,
    ),
    'weather' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'حالة الطقس',
      'nextduedate' => '0000-00-00',
      'pluginid' => '29',
      'style' => 0,
    ),
	'social_likes' => 
    array (
      'status' => 'Active',
      'version' => '1.0.1',
      'lastversion' => '1.0.1',
      'name' => 'سوشيال لايك',
      'nextduedate' => '0000-00-00',
      'pluginid' => '62',
    ),
  ),
  'status' => 'Active',
  'checkdate' => '20150331',
);


        if( !$data ) 
        {
            $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - ($localkeydays + $allowcheckfaildays), date("Y")));
            if( $localexpiry < $originalcheckdate ) 
            {
                $results = $localkeyresults;
            }
            else
            {
                $results["status"] = "Internal Error";
                $results["description"] = "Remote Check Failed";
                return $results;
            }

        }
        else
        {
            $results = $data;
        }

        if( $results["status"] == "Active" ) 
        {
            $results["checkdate"] = $checkdate;
            $data_encoded = serialize($results);
            $data_encoded = base64_encode($data_encoded);
            $data_encoded = md5($checkdate . DIMSECRETKEY) . $data_encoded;
            $data_encoded = strrev($data_encoded);
            $data_encoded = $data_encoded . md5($data_encoded . DIMSECRETKEY);
            $results["localkey"] = wordwrap(lencrypt($data_encoded), 80, "\n", true);
        }

        $results["remotecheck"] = true;
    }

    unset($data);
    unset($matches);
    unset($checkdate);
    unset($usersip);
    unset($localkeydays);
    unset($allowcheckfaildays);
    unset($md5hash);
    return $results;
}

function license_proccess($func, $localkeydays, $results = array(  ))
{
    global $dimofinf;
    global $dimphrase;
    global $hook;
    if( $func == "init" ) 
    {
        if( !$dimofinf->config["LicenseKey"] ) 
        {
            exit( "You did not set \$setting['LicenseKey'] in include/config.php" );
        }

        if( file_exists(LICENSE_FILE) ) 
        {
            $localkey = read_file_contents(LICENSE_FILE);
        }

        return docheck_license($dimofinf->config["LicenseKey"], $localkey, $localkeydays);
    }

    if( $results["status"] == "Active" && is_array($dimofinf->pluginscache) ) 
    {
        if( $results["localkey"] ) 
        {
            savefile(LICENSE_FILE, $results["localkey"]);
        }

        foreach( $dimofinf->pluginscache as $folder => $plugindata ) 
        {
            $plugin = $hook->get_plugins_data($folder);
            if( $hook->check_plugin_is_installed($folder) ) 
            {
                if( array_key_exists($folder, $results["plugins"]) ) 
                {
                    if( $results["plugins"][$folder]["status"] != "Active" ) 
                    {
                        error_message(fetch_message("plugin_issue", $folder, $results["plugins"][$folder]["status"]), iif(DIM_AREA == "admincp", "error", "dimofinf"));
                    }

                    if( is_newer_version($plugin["version"], $results["plugins"][$folder]["version"]) ) 
                    {
                        error_message(fetch_message("plugin_isnewer", $folder, $plugin["version"], $results["plugins"][$folder]["version"]), iif(DIM_AREA == "admincp", "error", "dimofinf"));
                    }

                }
                else
                {
                    error_message(fetch_message("plugin_issue", $folder, $dimphrase["plugin_notlicensed"]), iif(DIM_AREA == "admincp", "error", "dimofinf"));
                }

            }

        }
    }
    else
    {
        if( $results["status"] == "Internal Error" ) 
        {
            if( DIM_AREA == "admincp" ) 
            {
                error_message("<br /><b>" . $results["status"] . "</b><br />" . $results["description"]);
            }
            else
            {
                error_message("<br /><b>" . $results["status"] . "</b><br />" . $results["description"], "dimofinf", false);
            }

        }
        else
        {
            if( $results["status"] == "Invalid" ) 
            {
                if( DIM_AREA == "admincp" ) 
                {
                    error_message(fetch_message("invalid_l_data", $dimofinf->config["LicenseKey"]));
                }
                else
                {
                    error_message(fetch_message("invalid_l_data", $dimofinf->config["LicenseKey"]), "dimofinf", false);
                }

            }
            else
            {
                if( $results["status"] == "Expired" || $results["status"] == "Suspended" ) 
                {
                    if( DIM_AREA == "admincp" ) 
                    {
                        error_message(fetch_message("invalid_l_status", $results["status"]));
                    }
                    else
                    {
                        error_message(fetch_message("invalid_l_status", $results["status"]), "dimofinf", false);
                    }

                }

            }

        }

    }

}

function check_license($localkeydays = 10)
{
    global $dimofinf;
    global $dimphrase;
    global $hook;
    $results = license_proccess("init", $localkeydays);
    license_proccess("end", $localkeydays, $results);
    return $results;
}

function update_license($localkeydays = 0)
{
    $results = license_proccess("init", $localkeydays);
    license_proccess("end", $localkeydays, $results);
    return $results;
}

function get_dim_feed()
{

}

function get_dim_patches()
{

}

function get_dim_team()
{

}


